<template>
    <div>
        <form @submit="cadastrar">
            <input v-model='form.name' type="text" name="nome" class="form-control input mb-3" placeholder="NOME" required>
            <input v-model='form.phone' v-mask="'(##) # ########'" type="text" name="tel" class="form-control input mb-3" placeholder="TELEFONE OU CELULAR" required>
            <input v-model='form.cpf' v-mask="'###.###.###-##'" type="text" name="cpf" class="form-control input mb-3" placeholder="CPF" required>
            <input v-model='form.email' type="email" name="email" class="form-control input mb-3" placeholder="EMAIL" required>
            <input v-model='form.senha' type="password" name="senha" class="form-control input mb-3" placeholder="SENHA" required>
            <b-form-checkbox id="checkbox-1" v-model="form.type" name="checkbox-1" value="1" unchecked-value="2" switch>
                Tipo de Usuario: <strong><span v-if="form.type == 2">Cliente</span> <span v-else>Administrador</span></strong>
            </b-form-checkbox>

            <button type="submit" class="btn btn-success mt-4 w-100" >{{btn.txt}}</button>
            </form>
        <b-modal id="modalStatus" :header-bg-variant="alert.bg" centered  :header-text-variant="alert.color" header-class='border-0 ' body-class='d-none' :title="alert.msg" hide-body  hide-footer>
        </b-modal>
    </div>
</template>

<script>
import axios from 'axios'
export default {
  name: 'Cadastrar',
  data(){
    return{
      form: {
        name: null,
        phone: null,
        cpf: null,
        email: null,
        senha: null,
        type : 2
      },
      btn:{
          txt: "CADASTRAR"
      },
      alert: {
            bg: 'success',
            color: 'white',
            msg: 'Sucesso ao Cadastrar',
        }
    }
  },
  methods:{
    cadastrar(e){
      e.preventDefault()
      console.log(this.form)
        const _vn = this
        _vn.btn.txt = "CADASTRARNDO..."
        axios.post('https://7re2usa707.execute-api.us-east-1.amazonaws.com/production/user', _vn.form)
        .then(function (response) {
             _vn.btn.txt = "CADASTRAR"
            if(response.data.code == 200){
                _vn.form = {}
                let tipo = ''
                _vn.form.type == 1 ? tipo = 'Administrador' : tipo = 'Cliente'
                _vn.alert = {
                    bg: 'success',
                    color: 'white',
                    msg: `${tipo} cadastrado com sucesso :)`,
                }
                _vn.$bvModal.show("modalStatus")
            } else {
                _vn.alert = {
                    bg: 'danger',
                    color: 'white',
                    msg: `Erro ao Cadastrar :/`,
                }
                _vn.$bvModal.show("modalStatus")
            }
        })
        .catch(function (error) {
            console.log(error);
        });
    //   localStorage.setItem(this.form.email, this.form)
    }
  }
}
</script>
